// Class Code Set 21



// From Daniel Shiffman's Processing - Chaper 16

import processing.video.*;
Capture video;

color targetColor, currentColor;

float worldRecord, r1, r2,  g1, g2,  b1, b2, d;
float threshold = 100;
int closestX, closestY, loc;

void setup()
{
   size( 620, 480 );
   video = new Capture( this, 620, 480, 15 ); 
   
   targetColor = color( 255, 0, 0 );
   
   fill( targetColor);
   strokeWeight( 4.0 );
   stroke( 0 );
   
}

void draw( )
{
   
  if( video.available( )  )
  {
     video.read( );
  } 
  video.loadPixels();
  image( video, 0, 0 );
  
  worldRecord = 500;
  closestX = 0; 
  closestY = 0;
   
      for( int i = 0; i < video.pixels.length; i++)
      {
        currentColor = video.pixels[i];
        r1 = color( red(currentColor) );
        g1 = color( green(currentColor) );
        b1 = color( blue(currentColor) );
       
        d = dist( r1, g1, b1, r2, g2, b2 );
        
        if ( d < worldRecord )
        {
          worldRecord  = d;
          closestX = i%video.width;
          closestY = i/video.width;
        }
      }
      
      if (worldRecord < threshold )
      {
        ellipse( closestX, closestY, 16, 16 );
      }
  
}

void mousePressed(  )
{  
  int index = mouseX + mouseY*video.width;
  targetColor = video.pixels[index];
  r2 = color( red(targetColor) );
  g2 = color( green(targetColor) );
  b2 = color( blue(targetColor) );
}
