// Class Code Set 21



// From Daniel Shiffman's Processing - Chaper 16

import processing.video.*;
Capture video;

PImage  backgroundImage;
color bgColor, fgColor;

float  diff, threshold;

int  loc;

void setup()
{
   size( 620, 480 );
   video = new Capture( this, width, height, 30 ); 
   backgroundImage = createImage( video.width, video.height, RGB );
   
   threshold = 120;
}

void draw( )
{  
  if( video.available( )  )
  {
     video.read( );
  } 
  loadPixels( );
  video.loadPixels();
  backgroundImage.loadPixels( ); 
   
  for( int x = 0; x < video.width; x++)
  {
      for( int y = 0; y < video.height; y++)
      {
        loc = x + y*video.width;
        fgColor = video.pixels[loc];
        bgColor = backgroundImage.pixels[loc];
        
        float r1 = red(fgColor);
        float g1 = green(fgColor);
        float b1 = blue(fgColor);
        float r2 = red(bgColor);
        float g2 = green(bgColor);
        float b2 = blue(bgColor);
      
        diff = dist( r1, g1, b1, r2, g2, b2 );
        
        if ( diff > threshold )
        {
         pixels[loc] = fgColor;
        }
        else
        {
          pixels[loc] = color( 0, 255, 0 ); 
        }
      } // end inner for loop
  } // end outer for loop
  updatePixels();
}

void mousePressed(  )
{  
  backgroundImage.copy( video, 0, 0, video.width, video.height,
                               0, 0, video.width, video.height );
  backgroundImage.updatePixels( );                               
}
