// Class Code Set 21

// From Daniel Shiffman's Processing - Chaper 16

import processing.video.*;
Capture video;

PImage  previousFrame;

float  diff, threshold;

int  loc;

void setup()
{
   size( 640, 480 );
   video = new Capture( this, width, height, 30 ); 
   previousFrame = createImage( video.width, video.height, RGB );
   
   threshold = 120;
}

void draw( )
{  
  if( video.available( )  )
  {
     previousFrame.copy( video, 0, 0, video.width, video.height,
                                  0, 0, video.width, video.height );
     previousFrame.updatePixels( );        
     video.read( );
  } 
  loadPixels( );
  video.loadPixels();
  previousFrame.loadPixels( ); 
   
  for( int x = 0; x < video.width; x++)
  {
      for( int y = 0; y < video.height; y++)
      {
        loc = x + y*video.width;
        color current = video.pixels[loc];
        color previous = previousFrame.pixels[loc];
        
        float r1 = red(current);
        float g1 = green(current);
        float b1 = blue(current);
        float r2 = red(previous);
        float g2 = green(previous);
        float b2 = blue(previous);
      
        diff = dist( r1, g1, b1, r2, g2, b2 );
        
        if ( diff > threshold )
        {
         pixels[loc] = color( 0 );
        }
        else
        {
          pixels[loc] = color(  255 ); 
        }
      } // end inner for loop
  } // end outer for loop
  updatePixels();
}


